




# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

    get_trigger     ;#  update values

}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable HelpTopic "Trigger"

    variable TTypeList
    variable TGainList
    variable TSlopeList
    variable TDelayList
    variable TShiftList
    variable TIntList
    variable TDiffList

    variable TType
    variable TGain
    variable TSlope
    variable TRectify
    variable TEnable
    variable TForce
    variable TThreshold
    variable TDelay
    variable TShift
    variable TInt
    variable TDiff

    set TRectify 0
    set TEnable 0
    set TForce 0
    set TThreshold 0

    set TTypeList { \
       "Simple"  \
       "Digital"  \
       "CFD"  \
       "External"   \
    }

    set TGainList {  \
       "x(1/2)"   \
       "x(1/4)"   \
       "x(1/8)"   \
       "x(1/16)"   \
    }

    set TSlopeList { \
       "Positive"  \
       "Negative"  \
    }

    set TDelayList {0 1 2 3 4 5 6 7}
    set TShiftList {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}
    set TDiffList {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31}
    set TIntList {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31}


    set TType [lindex $TTypeList 0]
    set TGain [lindex $TGainList 0]
    set TSlope [lindex $TSlopeList 0]
    set TDelay [lindex $TDelayList 0]
    set TShift [lindex $TShiftList 0]
    set TInt [lindex $TIntList 0]
    set TDiff [lindex $TDiffList 0]


    proc set_trigger_defaults {} {       ;#   note copied to common.tcl

        set_trigger_register 0 1   ;# trigger enabled
        set_trigger_register 1 2   ;# differentiation constant
        set_trigger_register 2 4   ;# integration constant
        set_trigger_register 3 1   ;# digitial
        set_trigger_register 4 0x03e8    ;# threshold
        set_trigger_register 5 0   ;# force trigger disabled
        set_trigger_register 6 0   ;# positive slope
        set_trigger_register 7 7   ;# CFD trigger delay
        set_trigger_register 8 0   ;# CFD trigger gain
        set_trigger_register 9 0   ;# CFD trigger shift
        set_trigger_register 10 0xfff8    ;# rectify ??
   }

    proc get_trigger {} {
        variable TType
        variable TGain
        variable TSlope
        variable TRectify
        variable TEnable
        variable TForce
        variable TThreshold
        variable TDelay
        variable TShift
        variable TInt
        variable TDiff

    variable TTypeList
    variable TGainList
    variable TSlopeList

        set TEnable [expr [get_trigger_register 0] & 1]
        set TDiff [expr [get_trigger_register 1] & 0x1f]
        set TInt [expr [get_trigger_register 2] & 0x1f]
        set TDelay [expr [get_trigger_register 7] & 0x7]
        set TShift [expr [get_trigger_register 9] & 0xf]

        set vl [expr [get_trigger_register 3] & 0x3]
        set TType [lindex $TTypeList $vl]

        set vl [expr [get_trigger_register 8] & 0x3]
        set TGain [lindex $TGainList $vl]

        set vl [expr [get_trigger_register 6] & 0x1]
        set TSlope [lindex $TSlopeList $vl]

        set vl [expr [get_trigger_register 4] & 0x3fff]     ;# 14 bit signed
        if {$vl > 0x1fff} {set vl [expr ($vl & 0x1fff) - 8192]}
        set TThreshold $vl

        set TForce [expr [get_trigger_register 5] & 0x1]
        set TRectify [get_trigger_register 10] 
    }

   proc  show_variables {} {

        for {set i 0} {$i <= 10} {incr i} {
            set data [get_trigger_register $i]
            InsertLog "[set i] = [format \"0x%4x\" $data]"
        }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

     if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {

           set w [first [lindex $cgidata 1]]
           set vl [second [lindex $cgidata 1]]

           switch -glob $w {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                HELP     {do_help}

                Param    {
                    variable $vl
                    set $vl [lreplace [lindex $cgidata 1] 0 1]
                    switch $vl {
                       TDiff   {set_trigger_register 1 [set $vl]}
                       TShift  {set_trigger_register 9 [set $vl]}
                       TInt    {set_trigger_register 2 [set $vl]}
                       TType   {set_trigger_register 3 [set $vl]}
                       TGain   {set_trigger_register 8 [set $vl]}
                       TDelay  {set_trigger_register 7 [set $vl]}
                       TSlope  {set_trigger_register 6 [set $vl]}
                       TRectify   {set_trigger_register 10 [set $vl]}
                       TThreshold {set_trigger_register 4 [expr [set $vl] & 0x3fff]}
                    }
                }

                TENABLE  {if {$vl == "true"} then {set_trigger_register 0 1} else {set_trigger_register 0 0}}
                TFORCE   {if {$vl == "true"} then {set_trigger_register 5 1} else {set_trigger_register 5 0}}

                TDEFAULTS {set_trigger_defaults}

                MainLog {}
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

    get_trigger

}  ;# end of if {$started == 0}



